      program computefredholm
c     this program computes fredholm determinant and dzeta-function
      parameter (neq=17,ncyc=1000,nord=10) 
      implicit real*8 (a-h,o-z) 
      dimension rlam(neq,ncyc),t(ncyc),np(ncyc),explyap(neq) 
      dimension tp(ncyc),b(0:nord),a(0:nord),anew(0:nord)
      dimension isymb(nord),ibla(nord),icount(nord),np0(ncyc)  
      dimension t0(ncyc),a0(neq) 
      common/iparam/iord,ncyc1
      common/param/rlam,t
      common/iarrparam/np
      common/coeff/a
      external ffredholm 
      npmax=1000
c     opening the data files 
      
      open(10,file='cyc17.chaotic.dat',status='old') 
c     input:contains periodic orbit data
      open(18,file='zero17.chaotic.dat',status='unknown')
c     output:the escape rate is written here
      open(22,file='lyapfredh17.chaotic.dat',status='unknown')
c     output:the value of Lyapunov exponent is written here
      open(20,file='values17.chaotic.dat',status='unknown')
c     output:the values of Fredholm determinant as a funcion 
c     of s are written here
      open(26,file='coeff17.chaotic.dat',status='unknown')
c     output:coefficients of the fredholm determinant 


      i=1
      do k=1,nord
         ibla(k)=0
      enddo 
c     reading the data 

      do while (i.lt.npmax)
         read(10,*,end=50) np(i),(isymb(j),j=1,np(i)) 
c     computing  the # of zeroes 
         izero=0 
         do j=1,np(i)
            if (isymb(j).eq.0) then 
               izero=izero+1 
            endif 
         enddo 
         do j=1,np(i)
            read(10,*) (a0(k),k=2,neq)
         enddo
c     in the case of the 3-window, redefine the topological length:
c     subtract the nuber of zeroes in the symbolic sequence
c         np(i)=np(i)-izero
         read(10,*) t(i) 

         do j=1,neq
            read(10,*) rlam(j,i)   
         enddo 

c     finding the max of the eigenvalues 
         rmax=0 
         do k=1,neq 
            if (abs(rlam(k,i)).gt.rmax) then 
               rmax=rlam(k,i)
            endif
         enddo 

c     in the case of 3-window, discard the stable cycle
          if ((rmax.gt.1).and.(np(i).gt.0)) then 
            i1=np(i)
            do ii=1,nord 
               icount(ii)=ibla(ii) 
            enddo 
            ibla(i1)=ibla(i1)+1 
 25         format(8(1x,i4))
            i=i+1 
         endif 
      enddo 

 50    continue 
       ncyc1=0 
c     computing the total # of cycles 
       do k=1,nord
          ncyc1=ncyc1+ibla(k) 
          write(*,*) ibla(k),'cycles length',k
       enddo

c     writing the values of Fredholm determinant in the file 
       smin=-0.5
       smax=0.5
      
       maxs=500
       do iord=4,10,2
          do i=1,maxs
             s=smin+(smax-smin)/maxs*i 
             fal=ffredholm(s) 
             write(20,*) s,fal
c            do ii=0,iord
c              write(16,*) ii,log10(abs(a(ii))),log10(abs(b(ii))) 
c            enddo 
 100         format(12(2x,f8.4))
c     
          enddo
          write(20,*)
       enddo 
 
c     now computing escape rates (zeroes of fredholm and zeta functions 
       do iord=1,nord
c     the ends of the intervals 
          al=-0.5
          ar=0.5

          eps=1.d-12
          eta=1.d-12
          ifail=-1 
          fal=ffredholm(al) 
          far=ffredholm(ar) 
c     checking that fredholm has different signs at the ends of the interval 
          write(*,*) iord,'fredholm',al,fal,ar,far 
          
          ifail=-1
c     root-finding routine 
          call c05adf(al,ar,eps,eta,ffredholm,xfredholm,ifail)
c     the root is found, escape rate = xfredholm 
          if (ifail.eq.0) then 
             s=xfredholm
c     if required, write down the coefficients of fredholm 
c             if (iord.eq.nord) then  
c             do ii=0,iord
c                write(26,*) ii,log10(abs(a(ii))) 
c             enddo 
c             endif 
c     if the root does not exist, put s=0 
          else 
             s=0 
          endif 
c     compute lyapunov exponent 
          call  dfredholm(explyap,s,iord,ncycmax,ncyc1,neq,np,rlam,t)
          write(*,*) 'fredholm',explyap(1)
          write(22,200) iord,(explyap(jj),jj=1,neq)
            
          write(18,*) iord,xfredholm 
          write(*,*) iord,xfredholm 
       enddo
 200   format(i4,9(2x,f12.6)) 
       close(10) 
       stop
       end


      subroutine fredholm(value,s,nord,ncycmax,ncyc,neq,np,rlam,t,anew) 

      implicit real*8 (a-h,o-z) 
      dimension rlam(neq,ncycmax),t(ncycmax),np(ncycmax)
      dimension a(0:nord),anew(0:nord),b(0:nord),apow(0:nord) 
c      write(*,*) ncyc,ncycmax

       a(0)=0
       do i=1,nord
          a(i)=0
       enddo 
       do i=1,ncyc
          
c     NOW UPDATING THE COEFFICIENTS OF THE POLYNOMIAL 
c     computing the coefficient for the exponent  
c     computing the product over cycles and treir repeats 
         do ir=1,nord/np(i) 
            prod=1
c     calculating the term tp for the determinant 
            do j=1,neq 
c     ignore the second (transverse) eigenvalue
                 eps=1.d-5 
                 if (abs(1-rlam(j,i)).gt.eps) then 
                   prod=prod*abs(1-rlam(j,i)**ir)
                 endif
             enddo 
             tp=-exp(s*t(i)*ir)/(ir*prod)
c             write(*,*) 'tp=',tp,t(i),ir
             i1=ir*np(i) 
             if (i1.le.nord) then 
                a(i1)=a(i1)+tp 
             endif 
          enddo 
       enddo 
c     the sum in the exp is finished, now computing 
c     exp(polynomial) 
       call exppol(nord,a,anew) 
       value=0 
       do j=0,nord 
          value=value+anew(j)
       enddo 
       return
       end 




      subroutine product(nord,a,b,c) 
c     this subroutine computes a product of two polynomials 
c     \sum_{k=0}^nord a_k z^k * \sum_{k=0}^nord b_k z^k 
c      =\sum_{k=0}^nord c_k z^k
      implicit real*8 (a-h,o-z) 
      dimension a(0:nord),b(0:nord),c(0:nord) 

      do m=0,nord 
         c(m)=0 
         do k=0,m
               c(m)=c(m)+a(k)*b(m-k) 
          enddo 
       enddo 
       return 
       end 
      
      subroutine exppol(nord,a,expa) 
c     this subroutine computes exp of the polynomial a=sum a_k z^k 
      implicit real*8 (a-h,o-z) 
      dimension a(0:nord),expa(0:nord),apow(0:nord),b(0:nord)  
      expa(0)=1 
      apow(0)=1
      do i=1,nord 
         expa(i)=0
         apow(i)=0 
      enddo 
      do ii=1,nord
         call product(nord,a,apow,b) 
         do i=0,nord 
            apow(i)=b(i) 
         enddo 
c     now apow=a**(ii) 
         do i=0,nord 
            expa(i)=expa(i)+apow(i)/ifact(ii)
         enddo 
      enddo 
      return 
      end 
            
      function ifact(n) 
c     computing n!
      implicit real*8 (a-h,o-z) 
      
      prod=1
      do i=1,n 
         prod=prod*i
      enddo 
      ifact=prod
      return
      end 

      function ffredholm(s) 
      implicit real*8 (a-h,o-z)
      
      parameter (neq=17,ncycmax=1000,nord=10) 
      dimension rlam(neq,ncycmax),t(ncycmax),np(ncycmax)
      dimension a(0:nord) 
      common/param/rlam,t
      common/iarrparam/np
      common/iparam/iord,ncyc1
      common/coeff/a
c     a dummy routine to make a fredholm subroutine into a function 
c     to use with nag
      call  fredholm(value,s,iord,ncycmax,ncyc1,neq,np,rlam,t,a) 
      sum=0 
      do i=0,iord 
         sum=sum+a(i) 
      enddo
      ffredholm=value
      return 
      end 
      


      subroutine dfredholm(explyap,s,nord,ncycmax,ncyc,neq,np,rlam,t) 
c     computation of the lyapunov exponent 
      implicit real*8 (a-h,o-z) 
      dimension rlam(neq,ncycmax),t(ncycmax),np(ncycmax)
      dimension af(0:nord),a(0:nord),b(0:nord),c(0:nord)  
      dimension explyap(neq),up(0:nord),down(0:nord)   
c     a program to compute the Lyapunov exponent 

      call fredholm(value,s,nord,ncycmax,ncyc,neq,np,rlam,t,af)
      do jj=1,neq 
c     computiation of the numerator 
         
         do i=0,nord
            up(i)=0 
            down(i)=0 
         enddo 
         do i=1,ncyc
            do ir=1,nord/np(i)
c     sum  over cycles and their repeats  
               prod=1 
               do k=1,neq 
                  tiny=1.d-6 
                  if (abs(1-rlam(k,i)).gt.tiny) then 
                     prod=prod*abs(1-rlam(k,i)**ir)
                  endif 
               enddo
c     updating the coefficients for the sum 
               do i0=0,nord 
                  a(i0)=0 
                  b(i0)=0 
                enddo 
c     HERE WE DEFINE PHI_P TO GET THE LYAPUNOV EXPONENT, 
C     TO OBTAIN DIFFERENT AVERAGES, CHANGE A(I) 
                a(ir*np(i))=log(abs(rlam(jj,i)))/prod
                b(ir*np(i))=t(i)/prod 
                call product(nord,a,af,c) 
                do i0=0,nord 
                   up(i0)=up(i0)+c(i0) 
                enddo 
                call product(nord,b,af,c) 
                do i0=0,nord 
                   down(i0)=down(i0)+c(i0) 
                enddo 
            enddo 
         enddo
         valnum=0
         valdenom=0
         do i=0,nord 
            valnum=up(i)+valnum 
            valdenom=down(i)+valdenom 
         enddo 
        
         explyap(jj)=valnum/valdenom 

      enddo 
      return
      end 
      

