      program compute 
      implicit real*8 (a-h,o-z)
      parameter (neq=16,norb=10000,len=5)
      dimension perinit(neq,len,norb),isymb(len,norb),t(len,norb)  
      dimension s(len,norb),fs(len,norb),ilen(norb),inum(len,norb) 
      dimension yinit(neq),orb0(neq)   
c     this program computes the parametric map s->f(s) 

      open(10,file='fewcycles.dat',status='old') 
      open(12,file='parametric.dat',status='unknown') 
      iall=0 
c     reading the periodic points 
      do i=1,norb
         read(10,*,end=20) ilen(i),(isymb(j,i),j=1,ilen(i))
         iall=iall+ilen(i) 
         write(*,*) 'i=',i,ilen(i),len
         do j=1,ilen(i) 
            read(10,*) (perinit(k,j,i),k=2,neq) 
         enddo 
         if (i.eq.1) then 
c         if ((ilen(i).eq.1).and.(isymb(1,i).eq.0)) then 
            do k=2,neq 
               orb0(k)=perinit(k,1,i) 
            enddo 
            orb0(1)=0
         endif 
         read(10,*) pertot
c     computing the transition times, if these are  known, dicard
c     everything up to mark 15  
         do j=1,ilen(i) 
            do k=2,neq 
               yinit(k)=perinit(k,j,i)
c               write(*,*) k,j,perinit(k,j,i)
            enddo 
            inum(j,i)=0 
 
            yinit(1)=0 
            call compute_period(neq,yinit,per)
            t(j,i)=per 

         enddo 
 15      do j=1,neq 
            read(10,*) rlam
         enddo 
      enddo 

 20   iorb=i
      
      sprev=0 
      s(1,1)=0 
      fs(1,1)=0 
      inum(1,1)=1
      do i=1,iall
         dist=1000 
         do ii=1,iorb 
            do jj=1,ilen(ii) 
               if (inum(jj,ii).eq.0) then 
                  sum=0 
                  do kk=2,neq 
                     sum=sum+(perinit(kk,jj,ii)-orb0(kk))**2 
                  enddo 
                  sum=sqrt(sum)
c                  write(*,*) 'sum dist',sum,dist
                  if (sum.lt.dist) then 
                     io=ii
                     it=jj 
                     dist=sum 
                  endif 
               endif 
            enddo 
         enddo 
c         write(*,*) 'it io=',it,io 
         inum(it,io)=i
         s(it,io)=sprev+dist
         sprev=sprev+dist
         do k=2,neq
            orb0(k)=perinit(k,it,io)
         enddo 
      enddo 
      
      
       
c     all points are enumerated, now computing their images   

      do ii=1,iorb 
         do jj=1,ilen(ii) 
            iim=ii 
            jim=mod(jj,ilen(ii))+1 
            fs(jj,ii)=s(jim,iim) 
         enddo 
      enddo 
      iall0=0 
      do i0=1,iall 
         do i=1,iorb 
            do j=1,ilen(i) 
               if (abs(s(j,i)).lt.2) then 
                  if (inum(j,i).eq.i0) then 
                     iall0=iall0+1
                     write(12,50) ilen(i),s(j,i),fs(j,i),t(j,i),
     &                (isymb(mod(j+k,ilen(i))+1,i),k=1,ilen(i)) 
                  endif 
               endif 
            enddo 
 50         format(i4,3(f12.6),10(i2))
         enddo 
      enddo 
      write(*,*) 'total number of points', iall0
      stop
      end 
                     
      


      subroutine compute_period(neq,yinit,deltat) 
      implicit real*8 (a-h,o-z) 
      dimension y(neq),yinit(neq),w(neq,7),w1(neq,10)  
      external fcn 
c     a subroutine for computing the transition times 
      do i=2,neq
         y(i)=yinit(i)         
      enddo
      
      y(1)=0
c      do i=1,neq 
c         write(*,*) 'b',i,y(i)
c      enddo
      t=0 
      do ii=0,1 
         tol=1.d-8
         ifail=0
         t1=t+0.1 
         call d02baf(t,t1,neq,y,tol,fcn,w,ifail) 
         m=1 
         tend=10
         val=0 
         tol=1.d-8 
         ifail=0 
         hmax=1.d-1
         call d02bgf(t,tend,neq,y,tol,hmax,m,val,fcn,w1,ifail)
      enddo 
      deltat=t 
c     write(*,*) 'period=',deltat

      return
      end






      subroutine fcn(x,y,f)
      implicit real*8 (a-h,o-z)
      parameter (n=16,next=n,nbig=2*n)
      real*8 a(-nbig:nbig),f(n),y(n)
c     nag integration routine containing the equation
c     change it when using a different system 
      do i=0,nbig
         a(i)=0
         a(-i)=0
      enddo
      do i=1,n
         a(i)=y(i)
         a(-i)=-y(i)
      enddo

      x1=x

      vis=0.02991
      do k=1,n
         sum=0
         do i=-n,n
            sum=sum-k*(a(i)*a(k-i))
c     only odd solutions
         enddo

          f(k)=(k**2-vis*k**4)*a(k)+sum
c         write(*,*) x,y(1)
      enddo
      x1=x
      return
      end


 
